"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const log_helper_1 = require("../../shared/log-helper");
function updatePublicAPI(path, paths) {
    return (tree) => {
        try {
            const publicAPIFile = path + '/public-api.ts';
            tree.overwrite(publicAPIFile, generatePublicAPIcontent(paths));
        }
        catch (e) {
            console.error(e);
            log_helper_1.logError(`Something went wrong: Do you have multiple modules in ${path}`);
        }
    };
}
exports.updatePublicAPI = updatePublicAPI;
function generatePublicAPIcontent(paths) {
    let result = '';
    paths.forEach((path) => {
        if (!path.includes('spec.ts')) {
            result += `export * from '${path.split('.ts')[0]}';\n`;
        }
    });
    return result;
}
exports.generatePublicAPIcontent = generatePublicAPIcontent;
//# sourceMappingURL=update-public-api.rule.js.map